enum BTN {
    //% block="1"
    1,
    //% block="2"
    2,
    //% block="3"
    3,
    //% block="4"
    4,
    //% block="5"
    5,
    //% block="6"
    6,
    //% block="7"
    7,
    //% block="8"
    8,
    //% block="9"
    9,
    //% block="10"
    10,
    //% block="11"
    11,
    //% block="12"
    12,
    //% block="13"
    13,
    //% block="14"
    14,
    //% block="15"
    15,
    //% block="16"
    16,
    //% block="17"
    17,
    //% block="18"
    18,
    //% block="19"
    19,
    //% block="20"
    20
}


enum TEX {
    //% block="打开灯光"
    1,
    //% block="关闭灯光"
    2,
    //% block="灯光调亮"
    3,
    //% block="灯光调暗"
    4,
    //% block="打开风扇"
    5,
    //% block="关闭风扇"
    6,
    //% block="转速调快"
    7,
    //% block="转速调慢"
    8,
    //% block="打开摇头"
    9,
    //% block="关闭摇头"
    10,
    //% block="打开垃圾桶"
    11,
    //% block="关闭垃圾桶"
    12,
    //% block="晾衣服"
    13,
    //% block="收衣服"
    14,
    //% block="打开大门"
    15,
    //% block="关闭大门"
    16,
    //% block="播放音乐"
    17,
    //% block="停止播放"
    18,
    //% block="下一首"
    19,
    //% block="上一首"
    20,
    //% block="音量调高"
    21,
    //% block="音量调低"
    22,
    //% block="前进"
    23,
    //% block="后退"
    24,
    //% block="左转"
    25,
    //% block="右转"
    26,
    //% block="停止"
    27,
    //% block="播报温度"
    28,
    //% block="播报湿度"
    29
}



enum SER {
    //% block="asr[P16]，tts[P15]"
    1,
    //% block="asr[P15]，tts[P16]"
    2
}





//% color="#00AAAA" iconWidth=50 iconHeight=40
namespace asr {
    //% block="初始化[ser]" blockType="command"
    //% ser.shadow="dropdown"   ser.options="SER"     ser.defl="SER.P16"
    export function aasr1(parameter: any, block: any) {
            let ser = parameter.ser.code;


            if(ser==1){
                Generator.addObject(`asr01`, `volatile float`, `asr_num;`);
                Generator.addSetupMainTop("asr.begin", "Serial1.begin(9600, P16, P15);");           
            }else{
                Generator.addObject(`asr01`, `volatile float`, `asr_num;`);        
                Generator.addSetupMainTop("asr.begin", "Serial1.begin(9600, P15, P16);");
            }


            Generator.addObject(`BoFang`, `void`, `BoFang(const char* TTS_data) {
    unsigned char buffer1[12] = {0x7E,0x00,0x0A,0x01,0x00,0x03,0x03,0xEF,0x01,0x06,0x07,0xEF};
  Serial1.write(buffer1,12);
  delay(100);

  //帧长度的高低位
  char zhen_length_low;
  char zhen_length_high = 0;
  //字符长度
  char data_length_temp = strlen(TTS_data);
  //校验和
  char sum;
  //变量i，for循环里用
  size_t i;
  
  //帧数组
  unsigned char buffer[data_length_temp+30];
  
  //长度为9＋字符的长度
  zhen_length_low = 9 + data_length_temp;
  
  //校验和的前半部分
  sum = zhen_length_low + zhen_length_high + 2 + 3 + 3 + 232  + data_length_temp;
  
  //帧前半部分
  buffer[0] = (0x7E);
  buffer[1] = (zhen_length_high);
  buffer[2] = (zhen_length_low);
  buffer[3] = (0x02);
  buffer[4] = (0x00);
  buffer[5] = (0x03);
  buffer[6] = (0x03);
  buffer[7] = (0xE8);
  buffer[8] = (data_length_temp);
  
  //把字符加进去
  for(i=0;i<=data_length_temp;++i){
    buffer[9 + i] = (TTS_data[i]);
    //校验和的后半部分
    sum = sum + TTS_data[i];
  }
  
  //校验和
  buffer[9+strlen(TTS_data)] = (sum);
  //帧结尾
  buffer[10 + strlen(TTS_data)] = (0xef);
  
  
  //发送
  Serial1.write(buffer,(11 + data_length_temp));
  //等待发送完毕
  delay(data_length_temp*115);
}`);


    }



    //% block="---"
    export function noteSep1() {}


    //% block="听取语音输入" blockType="command"
    export function aasr2(parameter: any, block: any) {
        Generator.addCode(`asr_num = -1;`);
        Generator.addCode(`if (Serial1.available()) {`);
        Generator.addCode(`asr_num = Serial1.read();`);
        Generator.addCode(`}`);
    }



    //% block="语音指令[btn]" blockType="boolean"
    //% btn.shadow="dropdown"   btn.options="BTN"     btn.defl="BTN.1"
    export function aasr3(parameter: any) {
        let btn = parameter.btn.code;
        Generator.addCode(`asr_num==${btn}`);
    }

    //% block="语音指令[tex]" blockType="boolean"
    //% tex.shadow="dropdown"   tex.options="TEX"     tex.defl="TEX.1"
    export function aasr4(parameter: any) {
        let tex = parameter.tex.code;
        Generator.addCode(`asr_num==${tex}`);
    }

    //% block="---"
    export function noteSep2() {}



    //% block="合成并播放[ttstext]" blockType="command"
    //% ttstext.shadow="text"   ttstext.defl="你好啊"
    export function tts1(parameter: any) {
        let ttstext = parameter.ttstext.code;
	
        Generator.addCode(`BoFang(String(${ttstext}).c_str());`);
    }







}
